import { EditorModule } from "../module";
import { DesignComp } from "../objects/DesignTemp/DesignComp";
import { tipIcons } from "../objects/TipIcons";
import { ICompKeys } from "../typings";

type Action = {
  component: any;
  getValue?: (c: DesignComp) => 0 | 1;
  disable?: (this: EditorModule, c: DesignComp) => boolean;
  onClick: (this: EditorModule, c: DesignComp) => void;
};

export const treeNodeActions: { [name in ICompKeys]?: Action[] } & {
  default: Action[];
} = {
  default: [
    {
      component: tipIcons.visible,
      getValue: (comp) => (comp.layout.visible !== false ? 0 : 1),
      onClick(comp) {
        this.actions.switchCompVisible(comp);
      },
    },
    {
      component: tipIcons.delete,
      disable(comp) {
        return !this.store.pageCompIds.includes(comp.id);
      },
      onClick(comp) {
        this.actions.removeComp(comp.id);
      },
    },
  ],
  Page: [],
};
